//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  ۑJPEG 摜̕iݒ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0106 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, GDIPOBJ, GDIPAPI,  GDIPUTIL, ExtDlgs,
  ActiveX;

type
  TMyPanel = class(TCustomPanel)
  private
    FImageFilePath : String;
    FJPEGQuality   : Cardinal;
    procedure SetImageFilePath(const Value: String);
    procedure SetJPEGQuality(const Value: Cardinal);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    property ImageFilePath : String   read FImageFilePath write SetImageFilePath;
    property JPEGQuality   : Cardinal read FJPEGQuality   write SetJPEGQuality;
  end;

  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private 錾 }
    MyPanel : TMyPanel;
  protected

  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  JPEG,
  GifImg,
  pngimage;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  JPEG 摜̕iݒ';

  //TMyPanel𐶐Ĕzu
  MyPanel := TMyPanel.Create(Self);
  with MyPanel do begin
    Parent  := Self;
    Left    := 5;
    Top     := 35;
    Width   := Self.ClientWidth  - 10;
    Height  := Self.ClientHeight - Top - 5;
    Anchors := [akLeft, akTop, akRight, akBottom];
    Color   := clWhite;

    BevelOuter       := bvNone;
    ParentBackground := False;
    DoubleBuffered   := True;
  end;

  //i̐ݒp
  with TrackBar1 do begin
    ShowSelRange := False;
    TickStyle    := tsNone;
    Height   := 26;
    Min      := 0;
    Max      := 100;
    Position := 100;
  end;
end;

//=============================================================================
//  [摜t@C]{^
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;

  if OpenPictureDialog1.InitialDir = '' then begin
    OpenPictureDialog1.InitialDir := ExtractFileDir(ParamStr(0));
  end;

  OpenPictureDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  if OpenPictureDialog1.Execute then begin
    OpenPictureDialog1.InitialDir := ExtractFileDir(MyPanel.ImageFilePath);
    MyPanel.ImageFilePath         := OpenPictureDialog1.FileName;
  end;
end;

//=============================================================================
//  TrackBar1OnChangeCxg
//=============================================================================
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if not Assigned(MyPanel) then exit;
  MyPanel.JPEGQuality := TrackBar1.Position;
  Label1.Caption := IntToStr(TrackBar1.Position);
end;

{ TMyPanel }

//-----------------------------------------------------------------------------
//  RXgN^
//-----------------------------------------------------------------------------
constructor TMyPanel.Create(AOwner: TComponent);
begin
  inherited;
  FImageFilePath := '';
  FJPEGQuality   := 100;
end;

//-----------------------------------------------------------------------------
//  ImageFilePathvpeB̐ݒ胁\bh
//  \摜t@Cw肷
//-----------------------------------------------------------------------------
procedure TMyPanel.SetImageFilePath(const Value: String);
begin
  if not FileExists(Value) then exit;

  FImageFilePath := Value;
  Invalidate;
end;

//-----------------------------------------------------------------------------
//  JPEGQualityvpeB̐ݒ胁\bh
//-----------------------------------------------------------------------------
procedure TMyPanel.SetJPEGQuality(const Value: Cardinal);
begin
  if FImageFilePath = '' then exit;
  if FJPEGQuality <> Value then begin
    FJPEGQuality := Value;
    Invalidate;
  end;
end;

//-----------------------------------------------------------------------------
//  TMyPanelNXPaint\bh
//  ۂ̕`R[h
//-----------------------------------------------------------------------------
procedure TMyPanel.Paint;
var
  LObjWidth      : Integer;
  LObjHeight     : Integer;
  LGPImage       : TGPImage;
  LGPGraphic     : TGPGraphics;
  LEncoderParams : TEncoderParameters;
  LMemoryStream  : TMemoryStream;
  LIStrema       : IStream;
  LImageGUID     : TGUID;
begin
  inherited;
  if FImageFilePath = '' then exit;

  //摜t@CTGPImagẽCX^X𐶐Dƍ擾
  LGPImage   := TGPImage.Create(FImageFilePath);
  LObjWidth   := LGPImage.GetWidth;
  LObjHeight  := LGPImage.GetHeight;

  //摜TMyPanelCanvasɕ`
  LGPGraphic := TGPGraphics.Create(Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, 0, 0, LObjWidth, LObjHeight);

  //JPEG̕i֌W̒lTEncoderParametersR[h^̊eo[ɃZbg
  LEncoderParams.Count := 1;
  LEncoderParams.Parameter[0].Guid           := EncoderQuality;
  LEncoderParams.Parameter[0].Type_          := EncoderParameterValueTypeLong;
  LEncoderParams.Parameter[0].NumberOfValues := 1;
  LEncoderParams.Parameter[0].Value := @FJPEGQuality;

  LMemoryStream := TMemoryStream.Create;
  try
    //Xg[𐶐āCɕۑ
    GetEncoderClsid('image/jpeg', LImageGUID);
    LGPImage.Save(TStreamAdapter.Create(LMemoryStream), LImageGUID, @LEncoderParams);

    LGPImage.Free;
    //ۑJPEG摜ǂݏoĕ`
    LIStrema := TStreamAdapter.Create(LMemoryStream);
    LGPImage := TGPBitmap.Create(LIStrema);
    LGPGraphic.DrawImage(LGPImage, LObjWidth + 10, 0, LObjWidth, LObjHeight);
  finally
    LMemoryStream.Free;
  end;

  LGPImage.Free;
  LGPGraphic.Free;
end;

end.
